# Contract

The `Contract` entity offers a normalized representation of the Casper Network [Contract](https://docs.casper.network/developers/json-rpc/types_chain/#contract) without including entry point hashes, which can be queried separately using the [Contract entry point](/rest-api/contract-entry-point.md) API. Additionally, this entity omits the contract's named keys but utilizes them for identifying the contract's type.

## Properties

The `Contract` entity has the following properties:

| Property                | Type         | Description                                                                                                             |
| ----------------------- | ------------ | ----------------------------------------------------------------------------------------------------------------------- |
| `contract_hash`         | `string(64)` | Contract hash represented as a hexadecimal string. Unique contract identifier                                           |
| `contract_package_hash` | `string(64)` | Hash of the contract package, this contract version is a part of, represented as a hexadecimal string                   |
| `block_height`          | `uint64`     | Height of the block in which the contract was deployed to the network                                                   |
| `deploy_hash`           | `string(64)` | Hash of the deploy that deployed the contract to the network represented as a hexadecimal string                        |
| `contract_type_id`      | `uint8`      | Identifier representing the type of the contract, check the types list [here](/rest-api/contract/get-contract-types.md) |
| `timestamp`             | `uint16`     | Timestamp indicating when the contract was created                                                                      |
| `contract_version`      | `uint16`     | Version number associated with the contract                                                                             |
| `is_disabled`           | `bool`       | Indicates whether the contract is currently disabled                                                                    |
| `timestamp`             | `datetime`   | Timestamp indicating when the contract was created                                                                      |
| `contract_version`      | `uint16`     | Version number associated with the contract                                                                             |
| `is_disabled`           | `bool`       | Indicates whether the contract is currently disabled                                                                    |

**Example**

```json
{
  "contract_hash": "8a2feaa4e86841c1c6f40f1779e1e1cb1d9d4d52a0eb82a8962829646524e732",
  "contract_package_hash": "ae2feaa4e86841c1c6f40f1779e1e1cb1d9d4d52a0eb82a8962829646524e744",
  "deploy_hash": "1a2feaa4e86841c1c6f40f1779e1e1cb1d9d4d52a0eb82a8962829646524e755",
  "block_height": 2764649,
  "contract_type_id": 2,
  "timestamp": "2023-01-01T12:00:00Z",
  "contract_version": 1,
  "is_disabled": false
}
```

## Optional properties

Depending on the endpoint, the following optional properties may be included in the `Contract` entity:

| Property           | Type                                             | Description                                          |
| ------------------ | ------------------------------------------------ | ---------------------------------------------------- |
| `contract_package` | [ContractPackage](/rest-api/contract-package.md) | Contract package, this contract version is a part of |

## Relations

The `Contract` entity has the following relations with other entities:

| Entity                                                    | Mapping property             | Description                                                                                |
| --------------------------------------------------------- | ---------------------------- | ------------------------------------------------------------------------------------------ |
| [`Deploy`](/rest-api/deploy.md)                           | `contract_hash, deploy_hash` | Contracts are deployed to the network with a deploy call. Deploys can be the contract call |
| [`ContractEntrypoint`](/rest-api/contract-entry-point.md) | `contract_hash`              | Contracts can have endpoints                                                               |
| [`ContractPackage`](/rest-api/contract-package.md)        | `contract_package_hash`      | Contracts are different versions of the same smart contract under the contract package     |

## Endpoints

The `Contract` entity has the following endpoints:

* [Get contract](/rest-api/contract/get-contract.md)
* [Get contracts](/rest-api/contract/get-contracts.md)
* [Get contract package contracts](/rest-api/contract/get-contracts-by-contract-package.md)

## Relation endpoints

The `Contract` entity has the following relation endpoints:

* [Get contract entry points](/rest-api/contract-entry-point/get-contract-entry-points.md)
* [Get contract types](/rest-api/contract/get-contract-types.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cspr.cloud/rest-api/contract.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
